# class KEditToolbar | A dialog used to customize or configure toolbars. More...
Definition | `#include <kedittoolbar.h>`
Inherits | KDialogBase [public ]
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Methods

- KEditToolbar (KActionCollection *collection, const QString& xmlfile = QString::null, bool global = true, QWidget* parent = 0, const char* name = 0)
- KEditToolbar (KXMLGUIFactory* factory, QWidget* parent = 0, const char* name = 0)
- ~KEditToolbar ()

#### Signals

- void newToolbarConfig ()

#### Protected Slots

- virtual void slotOk ()
- virtual void slotApply ()
- void acceptOK (bool b)

## Detailed Description

This is a dialog used to customize or configure toolbars

This dialog only works if your application uses the XML UI framework for creating menus and toolbars. It depends on the XML files to describe the toolbar layouts and it requires the actions to determine which buttons are active.

Typically, you would include the KStdAction::configureToolbars() standard action in your application. In your slot to this action, you would have something like so:

     KEditToolbar dlg(actionCollection());
     if (dlg.exec())
     {
       createGUI();
     }

That code snippet also takes care of redrawing the menu and toolbars if you have made any changes.

If you are using KMainWindow's settings methods (either save/apply manually or autoSaveSettings), you should write something like:

     void MyClass::slotConfigureToolbars()
     {
       saveMainWindowSettings( KGlobal::config(), "MainWindow" );
       KEditToolbar dlg(actionCollection());
       connect(&dlg,SIGNAL(newToolbarConfig()),this,SLOT(slotNewToolbarConfig()));
       if (dlg.exec())
       {
          createGUI();
       }
     }

     void MyClass::slotNewToolbarConfig() // This is called when OK or Apply is clicked
     {
        ...if you use any action list, use plugActionList on each here...
        applyMainWindowSettings( KGlobal::config(), "MainWindow" );
     }

Note that the procedure is a bit different for KParts applications. In this case, you need only pass along a pointer to your application's KXMLGUIFactory object. The editor will take care of finding all of the action collections and xml files. The editor aims to be semi-intelligent about where it assigns any modifications. In other words, it will not write out part specific changes to your shell's xml file.

An example would be:

     saveMainWindowSettings( KGlobal::config(), "MainWindow" );
     KEditToolbar dlg(factory());
     connect(&dlg,SIGNAL(newToolbarConfig()),this,SLOT(slotNewToolbarConfig()));
     dlg.exec(); // Note that you shouldn't call createGUI(), so if() might not be even needed anymore

     ... // See above for slotNewToolbarConfig

KEditToolbar (KActionCollection *collection, const QString& xmlfile = QString::null, bool global = true, QWidget* parent = 0, const char* name = 0) | ### KEditToolbar

Constructor for apps that do not use components.

This is the only entry point to this class. You must pass along your collection of actions (some of which appear in your toolbars). The other two parameters are optional.

The second parameter, xmlfile(), is the name (absolute or relative) of your application's UI resource file. If it is left blank, then the resource file: share/apps/appname/appnameui.rc is used. This is the same resource file that is used by the default createGUI() function in KMainWindow so you're usually pretty safe in leaving it blank.

The third parameter, global(), controls whether or not the global resource file is used. If this is `true`, then you may edit all of the actions in your toolbars -- global ones and local one. If it is `false`, then you may edit only your application's entries. The only time you should set this to false is if your application does not use the global resource file at all (very rare).

Parameters:

collection | The collection of actions to work on.
xmlfile | The application's local resource file.
global | If `true`, then the global resource file will also be parsed.
parent | The parent of the dialog.
name | An internal name.

KEditToolbar (KXMLGUIFactory* factory, QWidget* parent = 0, const char* name = 0) | ### KEditToolbar

Constructor for KParts based apps.

The main parameter, factory(), is a pointer to the XML GUI factory object for your application. It contains a list of all of the GUI clients (along with the action collections and xml files) and the toolbar editor uses that.

Use this like so:

     KEditToolbar edit(factory());
     if ( edit.exec() )
     ...

Parameters:

factory | Your application's factory object
parent | The usual parent for the dialog.
name | An internal name.

~KEditToolbar () | ### ~KEditToolbar

void slotOk () | ### slotOk

[protected slots virtual slot]

Overridden in order to save any changes made to the toolbars

Reimplemented from KDialogBase.

void slotApply () | ### slotApply

[protected slots virtual slot]

idem

Reimplemented from KDialogBase.

void acceptOK (bool b) | ### acceptOK

[protected slots slot]

should OK really save?

void newToolbarConfig () | ### newToolbarConfig

[signal]

Signal emitted when 'apply' or 'ok' is clicked. Connect to it, to plug action lists and to call applyMainWindowSettings (see sample code in this class's documentation)

- Author: Kurt Granroth <granroth@kde.org>
- Generated: root@sparc.ports.openbsd.org on Wed May 2 09:37:45 2001, using kdoc 2.0a53.